<?php
/**
* @version 2.3.4
* @package PWebContact
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

// Joomla main index.php file
define('_JEXEC', 1);

define('DS', DIRECTORY_SEPARATOR); //j2.5
define('JPATH_BASE', str_replace( DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_pwebcontact', '', dirname(__FILE__) ));

require_once (JPATH_BASE .'/includes/defines.php');
require_once (JPATH_BASE .'/includes/framework.php');

$app = JFactory::getApplication('site');
$app->initialise();
// end

JResponse::allowCache(false);
JResponse::setHeader('Content-Type', 'text/plain');
JResponse::toString();

if (($module_id = $app->input->getInt('mid', 0)) > 0) 
{
	require_once (JPATH_BASE.'/modules/mod_pwebcontact/helpers/helper.php');
	
	$params = modPWebContactHelper::getParams($module_id);
	
	// Debug
	if ($app->getCfg('debug') OR $app->input->getInt('debug')) $params->set('debug', 1);
	
	define('PWEBCONTACT_DEBUG', $params->get('debug'));
	
	if (PWEBCONTACT_DEBUG) 
	{
		jimport('joomla.log.log');
		JLog::addLogger(array());
		
		JLog::add('Ajax response initialized', JLog::INFO, 'mod_pwebcontact');
	}
	
	// Language
	$lang = JFactory::getLanguage();
	if ($params->get('rtl', 2) == 2) {
		if ($lang->isRTL())
			$params->set('rtl', 1);
		else
			$params->set('rtl', 0);
	}
	$lang->load('mod_pwebcontact');
	
	if (PWEBCONTACT_DEBUG) JLog::add('Language file loaded', JLog::INFO, 'mod_pwebcontact');
	
	// Set media path
	$params->set('media_url', 	str_replace('modules/mod_pwebcontact/', '', JURI::base()).'media/mod_pwebcontact/');
	$params->set('media_path', 	JPATH_ROOT.'/media/mod_pwebcontact/');
	$params->set('upload_path', JPATH_ROOT.'/media/mod_pwebcontact/upload/'.$module_id.'/');
	
	
	if ($app->input->get('qqfile', '')) 
	{
		// Upload files
		$response =  modPWebContactUploader::upload();
	} 
	else 
	{
		// Submit message
		try {
		    $response = modPWebContactHelper::submit();
		} catch (Exception $e) {
			if (PWEBCONTACT_DEBUG) JLog::add($e->getMessage(), JLog::ERROR, 'mod_pwebcontact');
			$response = array('status' => 3, 'msg' => $e->getMessage(), 'debug' => $e->getMessage());
		}
		
		// delete atachments if respnse status is 1=success, 3,4=error
		// and set in configuration to delete after sending
		if (isset($response['status']) AND in_array($response['status'], array(1, 3, 4)) AND $params->get('attachment_delete') AND $params->get('attachment_type', 1))
		{
			if (PWEBCONTACT_DEBUG) JLog::add('Delete atachments', JLog::INFO, 'mod_pwebcontact');
			modPWebContactUploader::deleteAtachments();
		}
	}
	
	// Catch all system messages
	if (isset($response['debug'])) 
		$response['debug'] .= "\r\n";
	else 
		$response['debug'] = '';
	$messages = $app->getMessageQueue();
	foreach ($messages as $message)
	{
		$response['debug'] .= $message['type'] .': '. $message['message'] ."\r\n";
	}
	
	echo json_encode($response);
	
	if (PWEBCONTACT_DEBUG) JLog::add('Ajax response exit', JLog::INFO, 'mod_pwebcontact');
}
elseif ($app->input->getInt('getToken', 0)) 
{
	echo json_encode(array('token' => JSession::getFormToken()));
}

jexit();