<?php
/**
* @version 2.3.2
* @package PWebContact
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

defined('_JEXEC') or die( 'Restricted access' );

JFormHelper::loadFieldClass('Radio');

/**
 * Perfect-Web
 *
 * @subpackage	mod_pwebcontact
 * @since		1.6
 */
class JFormFieldPweb extends JFormFieldRadio
{
	protected $extension = 'mod_pwebcontact';
	protected $documentation = 'http://www.perfect-web.co/joomla/modules/ajax-popup-contact-form/documentation';
	
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();
		
		// check Joomla configuration
		jimport('joomla.mail.helper');
		if ( JMailHelper::isEmailAddress($app->getCfg('mailfrom')) == false ) 
		{
			$app->enqueueMessage('Set From email field in <a href="index.php?option=com_config#jform_mailfrom" onclick="Cookie.write(\'configuration\',\'server\')" target="_blank">Joomla! Global Configuration</a>', 'warning');
		}		
		
		// check module configuration
		$module_id = $app->input->getInt('id', 0);
		if ($module_id == 0) 
		{
			$module_cid = $app->input->get('cid', array(), 'array');
			if (count($module_cid)) $module_id = (int)$module_cid[0];
		}
		if ($module_id > 0) 
		{
			// get params
			include_once JPATH_ROOT.'/modules/mod_pwebcontact/helpers/helper.php';
			$params = modPWebContactHelper::getParams($module_id);
			
			// check if debug is on
			if ($params->get('debug', 0)) $app->enqueueMessage('Disable debug mode when finished testing!', 'notice');
			
			// check if upload directory is writable
			if ($params->get('show_upload', 0))
			{
				jimport('joomla.filesystem.folder');
				$path = '/media/mod_pwebcontact/upload/'.$module_id.'/';
				JFolder::create(JPATH_ROOT.$path);
				
				if (!is_writable(JPATH_ROOT.$path)) 
					$app->enqueueMessage('Upload directory is not writable: '.$path);
				elseif (!JFile::exists(JPATH_ROOT.$path.'index.html'))
					JFile::copy(JPATH_ROOT.'/media/mod_pwebcontact/index.html', JPATH_ROOT.$path.'index.html');
			}	
		}
		
		// add documentation toolbar button
		if (version_compare(JVERSION, '3.0.0') == -1) {
			$button = '<a href="'.$this->documentation.'" style="font-weight:bold;border-color:#025A8D;background-color:#DBE4E9;" target="_blank"><span class="icon-32-help"> </span> '.JText::_('MOD_PWEBCONTACT_DOCUMENTATION').'</a>';
		} else {
			$button = '<a href="'.$this->documentation.'" class="btn btn-small btn-info" target="_blank"><i class="icon-support"> </i> </span> '.JText::_('MOD_PWEBCONTACT_DOCUMENTATION').'</a>';
		}
		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $button, $this->extension.'-docs');
		
		// add script
		$doc->addScript(JURI::root(true).'/media/mod_pwebcontact/js/admin.js');

		// add feed script
		if ($this->value)
		{
			$doc->addScriptDeclaration(
				'(function(){'.
				'var pw=document.createElement("script");pw.type="text/javascript";pw.async=true;'.
				'pw.src="//www.perfect-web.co/updates/feed.js?ext='.$this->extension.'&j='.JVERSION.'";'.
				'var s=document.getElementsByTagName("script")[0];s.parentNode.insertBefore(pw,s);'.
				'})();'
			);
		}
		
		return parent::getInput();
	}
}