<?php
/**
* @version 2.3.3
* @package PWebContact
* @subpackage Community Builder
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modPWebContactComprofilerHelper
{
	public static function isUserProfileView() 
	{
		$app = JFactory::getApplication();
		if ( $app->input->get('option') == 'com_comprofiler' && $app->input->get('task') == 'userprofile' && ($profile_id = $app->input->getInt('user', 0)) ) {
			//check if current user has access rights
			if (self::hasAccessRights($profile_id)) return true;
		}
		
		return false;
	}
	
	
	public static function getHiddenField() 
	{
		$app 	= JFactory::getApplication();
		$params = modPWebContactHelper::getParams();
		$html 	= '';
		
		if ( $params->get('comprofiler') && ($profile_id = $app->input->getInt('user', 0)) ) {
			
			if ($params->get('comprofiler_userprofile')) {
				$html = '<input type="hidden" name="comprofiler" value="'.$profile_id.'" />';
			}
			elseif ($app->input->get('option') == 'com_comprofiler' && $app->input->get('task') == 'userprofile') {
				//check if current user has access rights
				if (self::hasAccessRights($profile_id)) {
					$html = '<input type="hidden" name="comprofiler" value="'.$profile_id.'" />';
				}
			}
		}
		return $html;
	}
	
	
	public static function getEmail($profile_id = 0) 
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		
		//get Community Builder user email
		$query->select('u.email');
		$query->from('#__comprofiler AS c');
		$query->join('LEFT', '#__users AS u ON u.id = c.user_id');
		$query->where('c.id = ' . $profile_id);
		
		$db->setQuery($query);
		$email = $db->loadResult();
		
		if ($error = $db->getErrorMsg()) {
			if (PWEBCONTACT_DEBUG) JLog::add('Community Builder query error: '.$error, JLog::ERROR, 'mod_pwebcontact');
			return false;
		}
		if (!empty($email)) {
			return $email;
		}
		
		return false;
	}
	
	
	private static function hasAccessRights($profile_id = 0) 
	{
	
	}
}