<?php
/**
* @version 2.3.4
* @package PWebContact
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (dirname(__FILE__).'/comprofiler.php');
require_once (dirname(__FILE__).'/jomsocial.php');
require_once (dirname(__FILE__).'/sobipro.php');

require_once (dirname(__FILE__).'/uploader.php');

class modPWebContactHelper
{
	protected static $params = null;
	
	
	public static function setParams(&$params) 
	{
		self::$params = $params;
	}
	
	
	public static function getParams($module_id = 0) 
	{
		if (!self::$params AND $module_id > 0)
		{
			jimport('joomla.registry.registry');
		
			$db = JFactory::getDBO();
			$query = $db->getQuery(true);
			$query->select('params');
			$query->from('#__modules');
			$query->where('id='.(int)$module_id);
			$db->setQuery($query);
			$params_str = $db->loadResult();
			
			$params = new JRegistry($params_str);
			$params->def('id', (int)$module_id);
				
			self::$params = $params;
		}
		return self::$params;
	}
	
	
	public static function addAjaxScript() 
	{
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();
		
		$params = self::getParams();
		
		$module_id = (int)$params->get('id');
		$media_url = $params->get('media_url');
		
		if ($params->get('show_upload', 0)) 
		{
			$doc->addStyleSheet($media_url.'css/uploader.css');
			if ($params->get('rtl', 0)) 
				$doc->addStyleSheet($media_url.'css/uploader-rtl.css');
			
			$doc->addScript($media_url.'js/uploader.js');
		}
		
		$doc->addScript($media_url.'js/mootools.pwebcontact.js');
		
		$redirect = '';
		if ($params->get('redirect_enable', 0)) {
			if ($params->get('redirect_itemid', 0) > 0) {
				$redirect = JRoute::_('index.php?Itemid='.$params->get('redirect_itemid', 1), false);
			} elseif ($params->get('redirect_url')) {
				$redirect = JRoute::_($params->get('redirect_url'), false);
			}
		}
		
		$script = 
		'(function($){'.
			'pwebContact'.$module_id.'=new pwebContact({'.
				'id:"'.$module_id.'",'.
				'basePath:"'.JURI::base(true).'",'.
				'charsLimit:'.(int)$params->get('chars_limit', 0).',';
				
				if ($params->get('use_root_path', 0))
					$script .= 'rootPath:1,';
				if ($params->get('ssl', 0))
					$script .= 'ssl:1,';
				
				if ($params->get('debug', 0))
					$script .= 'debug:1,';
				
				if ($app->getCfg('caching') OR $params->get('cache', 0))
					$script .= 'reloadToken:1,';
					
				if ($params->get('open_form'))
					$script .= 'openFormOnStart:1,';
					
				// reset form after email has been sent
				if ($params->get('reset_after_send'))
					$script .= 'resetAfterSend:1,';
				
				if (!$params->get('reposition_form', 1))
					$script .= 'reposition:0,';
					
				if ($redirect) {
					$script .= 
					'redirectURL:"'.$redirect.'",'.
					'redirectTimeout:'.(int)$params->get('redirect_delay', 0).',';
				}
				
				if ($params->get('style_opacity'))
					$script .= 'bgOpacity:'.(float)$params->get('style_opacity').',';
			
				$script .= 
				'onEmailSuccess:function(){';
				// Google Analytics Tracking
				if ($params->get('analytics_tracker_enabled', 0)) {
					if ($params->get('analytics_tracker_type', 1)) {
						if ($params->get('analytics_tracker_page'))
							$script .= 'if(typeof _gaq!="undefined")_gaq.push(["_trackPageview","'.$params->get('analytics_tracker_page').'"]);';
						if ($params->get('analytics_tracker_event'))
							$script .= 'if(typeof _gaq!="undefined")try{_gaq.push(["_trackEvent",'.$params->get('analytics_tracker_event').'])}catch(e){};';
					} else { 
						if ($params->get('analytics_tracker_page'))
							$script .= 'if(typeof pageTracker!="undefined")pageTracker._trackPageview("'.$params->get('analytics_tracker_page').'");';
						if ($params->get('analytics_tracker_event'))
							$script .= 'if(typeof pageTracker!="undefined")try{pageTracker._trackEvent('.$params->get('analytics_tracker_event').')}catch(e){};';
					}
				}
				// Google AdWords Conversion Tracking
				if ($params->get('adwords_url')) {
					$script .= 'new Element("img",{"src":"'.$params->get('adwords_url').'","width":1,"height":1,"border":0}).inject(this.Msg);';
				}
				// Microsoft adCenter Conversion Tracking
				if ($params->get('adcenter_url')) {
					$script .= 'new Element("iframe",{"src":"'.$params->get('adcenter_url').'","width":1,"height":1,"frameborder":0,"scrolling":"no",styles:{"visibility":"hidden","display":"none"}}).inject(this.Msg);';
				}
				// Custom tracking script
				if ($params->get('custom_script')) {
					$script .= "\r\n".'try{'.strip_tags($params->get('custom_script'))."\r\n".'}catch(e){console.log(e.message)}';
				}
				$script .= 
				'},';
				
				// Uploader
				if ($params->get('show_upload', 0)) {
					$script .= 'uploader:1,';
					if ($params->get('upload_allowed_ext'))
						$script .= 'allowedExtensions:["'.implode('","', explode(',', $params->get('upload_allowed_ext'))).'"],';
						
					// max file size in bytes
					if ($sizeLimit = (int)$params->get('upload_size_limit', 500)) {
						$sizeLimit *= 1024;
						$script .= 'sizeLimit:'.$sizeLimit.',';
					}
					if (!$params->get('upload_show_size_limit', 1))
						$script .= 'showSizeLimit:0,';
					
					// max files limit
					if ($fileLimit = (int)$params->get('upload_file_limit', 3))
						$script .= 'fileLimit:'.$fileLimit.',';
				}
				
				// Lightbox window
				if ($params->get('layout') == 'modal') {
					$script .= 
					'modal:{'.
						'x:'.(int)$params->get('modal_width', 580).','.
						'y:'.(int)$params->get('modal_height', 320).','.
						'overlayOpacity:'.(float)$params->get('modal_opacity', 0.7).','.
						'classWindow:"'.$params->get('style_modal', 'blue').'"'.
					'},';
				}
				$script .= 
				'layout:"'.$params->get('layout').'"'.
			'})'. 
		'})(document.id);';
		
		if ($params->get('debug') AND !defined('MOD_PWEBCONTACT_JTEXT'))
		{
			$script = 
			'window.addEvent("domready",function(){'.
				'if(typeof pwebContact'.$module_id.'Count=="undefined"){'.
					// Check if document header has been loaded
					'if(typeof pwebContact=="undefined"||typeof pwebContactJText=="undefined")alert("PWeb debug: Contact form module has been loaded incorrect.'.
					(JPluginHelper::isEnabled('system', 'modulesanywhere') ? ' Do not use Modules Anywhere to load contact form inside template.' : '').'");'.
					// Check if Form Validator has been loaded
					'if(!document.formvalidator&&typeof JFormValidator!="undefined")alert("PWeb debug: Joomla MooTools Form Validator is broken by other JavaScript library.");'.
					// Check if one module instance has been loaded only once
					'pwebContact'.$module_id.'Count=$$(".pwebcontact'.$module_id.'_form").length;'.
					'if(pwebContact'.$module_id.'Count>1)'.
						'alert("PWeb debug: Contact form module ID '.$module_id.' has been loaded "+pwebContact'.$module_id.'Count+" times. You can have multiple contact forms, but one instance of module can be loaded only one time!")'.
				'}'.
			'});'.
			$script
			;
		}
		
		if (!defined('MOD_PWEBCONTACT_JTEXT')) {
			define('MOD_PWEBCONTACT_JTEXT', 1);
			
			$doc->addScriptDeclaration(
				'pwebContactJText={'.
					'token:"'.JText::_('MOD_PWEBCONTACT_TOKEN_ERROR').'",'.
					'sending:" '.JText::_('MOD_PWEBCONTACT_SENDING').'",'.
					'sent:"'.JText::_('MOD_PWEBCONTACT_MAIL_ALREADY_SENT').'",'.
					'browse:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_BROWSE').'",'.
					'cancel:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_CANCEL').'",'.
					'retry:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_RETRY').'",'.
					'dropFiles:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_DROP_FILES').'",'.
					'sizeLimit:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_SIZE_LIMIT').'",'.
					'formatProgress:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_FORMAT_PROGRESS').'",'.
					'failed:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_ERR').'",'.
					'typeError:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_EXT_ERR').'",'.
		            'sizeError:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_MAXSIZE_ERR').'",'.
		            'minSizeError:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_MINSIZE_ERR').'",'.
					'fileLimitError:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_FILE_LIMIT_ERR').'",'.
		            'emptyError:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_EMPTY_ERR').'",'.
					'noFilesError:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_NO_FILES_ERR').'",'.
		            'onLeave:"'.JText::_('MOD_PWEBCONTACT_UPLOAD_ONLEAVE').'"'.
				'};'
			);
			
			if ($params->get('debug')) {
				$doc->addScriptDeclaration(
					'(function(){'.
						// Check if MooTools has been loaded
						'if(typeof MooTools=="undefined")alert("PWeb debug: Joomla MooTools is not loaded or broken by other JavaScript library.");'.
						// Check if correct version of MooTools has been loaded
						'else if(MooTools.version.indexOf("1.4")!=0)alert("PWeb debug: Your template or other extension has changed Joomla MooTools version from 1.4.x to "+MooTools.version);'.
					'})();'
				);
			}
		}

		return $script;
	}
	
	
	public static function addAnalyticsScript() 
	{
		$params = self::getParams();
		
		if ( $params->get('analytics_script', 0) AND $params->get('analytics_id') != '' ) {
			$doc = JFactory::getDocument();
		
			if ($params->get('analytics_tracker_type', 1)) {
				
				$code = 'var _gaq=_gaq||[];'.
                        '_gaq.push(["_setAccount","'.$params->get('analytics_id').'"]);'.
                        '_gaq.push(["_trackPageview"]);'.
                        '(function(){'.
                        'var ga=document.createElement("script");ga.type="text/javascript";ga.async=true;'.
                        'ga.src=("https:"==document.location.protocol?"https://ssl":"http://www")+".google-analytics.com/ga.js";'.
                        'var s=document.getElementsByTagName("script")[0];s.parentNode.insertBefore(ga,s);'.
                        '})();';
			} else {
				
				$code = 'var gaJsHost=(("https:"==document.location.protocol)?"https://ssl.":"http://www.");'.
						'document.write(unescape("%3Cscript src=\'"+gaJsHost+"google-analytics.com/ga.js\' type=\'text/javascript\'%3E%3C/script%3E"));'.    
						"\r\n".'</script><script type="text/javascript">'."\r\n".
						'try{'.
                        'var pageTracker=_gat._getTracker("'.$params->get('analytics_id').'");'.
                        'pageTracker._trackPageview();'.
                        '}catch(err){}';
			}	
			$doc->addScriptDeclaration($code);
		}
	}
	
	
	public static function getTemplateStyles() 
	{
		$styles = array();
		
		$params = self::getParams();
		
		$media_path = $params->get('media_path');
		$media_url 	= $params->get('media_url');
		
		switch ($params->get('layout'))
		{
			case 'modal':
				$styles['toggler'] = 
					($params->get('style_top') ? 'top:'.$params->get('style_top').';' : '') .
					($params->get('style_left') ? 'left:'.$params->get('style_left').';' : '') .
					($params->get('style_btn_width') > 0 ? 'width:'.((int) $params->get('style_btn_width')).'px;' : '') .
					($params->get('style_btn_height') > 0 ? 'height:'.((int) $params->get('style_btn_height')).'px;' : '')
					;
				if ($vertical = $params->get('toggle_vertical'))
				{
					$lang_code = JFactory::getLanguage()->getTag();
					$toggler_path = 'images/toggler/'.(int)$params->get('id').'-'.$lang_code.'.png';
					if ($vertical == 2 OR !file_exists($media_path.$toggler_path)) 
						self::createToggleImage();
					$styles['toggler'] .= 'background-image:url('.$media_url.$toggler_path.');';
				}
				$styles['icon'] = 
					($params->get('style_btn_icon') ? 'background-image:url('.$media_url.'images/icons/'.$params->get('style_btn_icon').');' : '')
					;
				$styles['modal'] = 
					($params->get('modal_image') ? 'background-image:url('.$params->get('modal_image').');' : '').
					($params->get('style_font') ? 'font-size:'.$params->get('style_font').';' : '') .
					($params->get('style_color') ? 'color:'.$params->get('style_color').';' : '')
					;
				break;
				
			case 'static':
				$styles['box'] = 
					($params->get('style_font') ? 'font-size:'.$params->get('style_font').';' : '') .
					($params->get('style_color') ? 'color:'.$params->get('style_color').';' : '')
					;
				break;
				
			case 'default':
			default:
				$styles['toggler'] = 
					($params->get('style_btn_width') > 0 ? 'width:'.((int) $params->get('style_btn_width')).'px;' : '') .
					($params->get('style_btn_height') > 0 ? 'height:'.((int) $params->get('style_btn_height')).'px;' : '') .
					($params->get('style_bg') ? 'background-color:'.$params->get('style_bg').';' : '')
					;
				if ($vertical = $params->get('toggle_vertical'))
				{
					$lang_code = JFactory::getLanguage()->getTag();
					$toggler_path = 'images/toggler/'.(int)$params->get('id').'-'.$lang_code.'.png';
					if ($vertical == 2 OR !file_exists($media_path.$toggler_path)) 
						self::createToggleImage();
					$styles['toggler'] .= 'background-image:url('.$media_url.$toggler_path.');';
				}
				$styles['icon'] = 
					($params->get('style_btn_icon') ? 'background-image:url('.$media_url.'images/icons/'.$params->get('style_btn_icon').');' : '')
					;
				$styles['box'] = 
					($params->get('style_top') ? 'top:'.$params->get('style_top').';' : '') .
					($params->get('style_left') ? 'left:'.$params->get('style_left').';' : '') .
					($params->get('style_font') ? 'font-size:'.$params->get('style_font').';' : '') .
					($params->get('style_color') ? 'color:'.$params->get('style_color').';' : '')
					;
				$styles['bg'] = 
					($params->get('style_bg') ? 'background-color:'.$params->get('style_bg').';' : '')
					;
		}
		
		foreach ($styles as &$style) 
			if ($style) $style = ' style="'.$style.'"';
		
		return $styles;
	}


	protected function createToggleImage()
	{
		$params 		= self::getParams();
		
		$media_path 	= $params->get('media_path');
		$lang_code 		= JFactory::getLanguage()->getTag();
		
		$toggler_path 	= $media_path.'images/toggler/'.(int)$params->get('id').'-'.$lang_code.'.png';
		$font_path 		= $media_path.'images/font.ttf';
				
		$text 			= $params->get('toggle_button', JText::_('MOD_PWEBCONTACT_TOGGLE_BUTTON'));
		$font_size 		= (int)$params->get('style_font', 12);
		
		$width 			= is_numeric($params->get('style_btn_width')) ? $params->get('style_btn_width') + 20 : $font_size * 1.35;
	    $height 		= is_numeric($params->get('style_btn_height')) ? $params->get('style_btn_height') - 30 : strlen($text) * $font_size / 1.5;
		
		$rotate 		= (int)$params->get('toggle_rotate', 1);
		if ($params->get('rtl', 2) == 1) $rotate = 0 - $rotate;
		
		// Parse font color
		$color = $params->get('style_color');
		if ($color)
		{
			$color = trim($color);
			// parse hex color
			if (preg_match('/^\#([0-9abcdef]{1,2})([0-9abcdef]{1,2})([0-9abcdef]{1,2})$/i', $color, $match)) 
			{
				if (strlen($match[1]) == 2)
				{
					$color= array(
						'r' => hexdec($match[1]),
						'g' => hexdec($match[2]),
						'b' => hexdec($match[3])
					);
				}
				else 
				{
					$color= array(
						'r' => hexdec($match[1].$match[1]),
						'g' => hexdec($match[2].$match[2]),
						'b' => hexdec($match[3].$match[3])
					);
				}
			}
			// parse rgb color
			elseif (preg_match('/\((\d+),(\d+),(\d+)/i', $color, $match))
			{
				$color = array(
					'r' => $match[1],
					'g' => $match[2],
					'b' => $match[3]
				);
			}
		}
		if (!is_array($color)) $color = array('r' => 255, 'g' => 255, 'b' => 255);
		
		// create image
		$im = @imagecreatetruecolor($width, $height);
		imagesavealpha($im, true);
		imagealphablending($im, false);
		
		// set transparent background color
		$bg = imagecolorallocatealpha($im, 255, 0, 255, 127);
		imagefill($im, 0, 0, $bg);
		
		// set font color
		$font_color = imagecolorallocate($im, $color['r'], $color['g'], $color['b']);
		
		// display text
		if ($rotate > 0)
			imagettftext($im, $font_size, -90, $width * 0.25, 0, $font_color, $font_path, $text);
		else
			imagettftext($im, $font_size, 90, $width * 0.75, $height, $font_color, $font_path, $text);
			
		// save image
		imagepng($im, $toggler_path);
		imagedestroy($im);
	}
	
	
	public static function getHTMLfiled($type, $name, $required = false, $values = null, $module_id = null) 
	{
		$i = 0;
		
		switch ($type) {
			case 'select':
				$optValues = explode('|', $values);
				
				$html = '<select name="'.$name.'[]" id="pwebcontact'.$module_id.'_'.$name.'" class="inputbox'.($required ? ' required' : '').'">'.
						'<option value="">'.JText::_( 'MOD_PWEBCONTACT_SELECT' ).'</option>';
				foreach ($optValues as $value) {
					$html .= '<option value="'.addslashes($value).'">'.$value.'</option>';
				}
				$html .= '</select>';
				
				break;
			case 'multiple':
				$optValues = explode('|', $values);
				
				$html = '<select name="'.$name.'[]" id="pwebcontact'.$module_id.'_'.$name.'" multiple="multiple" size="4" class="inputbox multiple-select'.($required ? ' required' : '').'">';
				foreach ($optValues as $value) {
					$html .= '<option value="'.addslashes($value).'">'.$value.'</option>';
				}
				$html .= '</select>';
				
				break;
			case 'radio':
				$optValues = explode('|', $values);
				
				$html = '<fieldset id="pwebcontact'.$module_id.'_'.$name.'" class="pwebcontact_fields_group radio'.($required ? ' required' : '').'">';
				foreach ($optValues as $value) {
					$html .= '<label class="inline pwebcontact_'.$name.'_lbl'.$i.'">'
							.'<input type="radio" id="pwebcontact'.$module_id.'_'.$name.($i++).'" name="'.$name.'[]" value="'.addslashes($value).'" /> <span>'.$value.'</span>'
							.'</label>';
				}
				$html .= '<div class="clear"></div></fieldset>';
				
				break;
			case 'checkbox':
				$optValues = explode('|', $values);
				
				$html = '<fieldset id="pwebcontact'.$module_id.'_'.$name.'" class="pwebcontact_fields_group checkboxes'.($required ? ' required' : '').'">';
				foreach ($optValues as $value) {
					$html .= '<label class="inline pwebcontact_'.$name.'_lbl'.$i.'">'
							.'<input type="checkbox" id="pwebcontact'.$module_id.'_'.$name.($i++).'" name="'.$name.'[]" value="'.addslashes($value).'" /> <span>'.$value.'</span>'
							.'</label>';
				}
				$html .= '<div class="clear"></div></fieldset>';
				
				break;
			case 'textarea':
				$html = '<textarea name="'.$name.'[]" id="pwebcontact'.$module_id.'_'.$name.'" cols="50" rows="10" class="inputbox'.($required ? ' required' : '').'">'.$values.'</textarea>';
				break;
			case 'calendar':
				$html = JHTML::_('calendar', $values, $name.'[]', 'pwebcontact'.$module_id.'_'.$name, '%d-%m-%Y', array('class'=>'inputbox pwebcontact_date'.($required ? ' required' : ''), 'size'=>'30',  'maxlength'=>'10'));
				break;
			case 'knob':
				$knob = explode('|', $values);
				$min = isset($knob[0]) ? $knob[0] : 1;
				$max = isset($knob[1]) ? $knob[1] : 100;
				$steps = isset($knob[2]) ? $knob[2] : 20;
				$default = isset($knob[3]) ? $knob[3] : $min;
				
				JHtml::_('behavior.framework', true);
				$doc = JFactory::getDocument();
				$doc->addScriptDeclaration(
					'window.addEvent("domready",function(){'
						.'var pwebContact'.$module_id.'Slide'.$name.'=new Slider(document.id("area-pwebcontact'.$module_id.'_'.$name.'"),document.id("knob-pwebcontact'.$module_id.'_'.$name.'"),{'
							.'steps:'.$steps.','
							.'onChange:function(s){document.id("pwebcontact'.$module_id.'_'.$name.'").value=('.round($max / $steps, 4).'*s).limit('.$min.','.$max.').round(2);}'
						.'}).set('.round($default/$max*$steps).');'
						.'document.id("pwebcontact'.$module_id.'_'.$name.'").addEvent("blur",function(){'
							.'pwebContact'.$module_id.'Slide'.$name.'.set(parseInt(this.value/'.$max.'*'.$steps.'));'
						.'});'
					.'});');
					
				$html = '<input type="text" name="'.$name.'[]" id="pwebcontact'.$module_id.'_'.$name.'" size="30" class="inputbox'.($required ? ' required' : '').'" value="'.$default.'" />'
						.'<div id="area-pwebcontact'.$module_id.'_'.$name.'" class="pwebcontact_area"><div id="knob-pwebcontact'.$module_id.'_'.$name.'" class="pwebcontact_knob"></div></div>';
				break;
			case 'text':
			default:
				$html = '<input type="text" name="'.$name.'[]" id="pwebcontact'.$module_id.'_'.$name.'" size="30" class="inputbox'.($required ? ' required' : '').'" value="'.$values.'" />';
		}
		return $html;
	}

	
	public static function getMailtoSelectList($text, $module_id = null) 
	{
		$rows = explode("\n", $text);
		$i = 0;
		
		$html = '<select name="mailto" id="pwebcontact'.$module_id.'_mailto" class="inputbox required">'.
				'<option value="">'.JText::_( 'MOD_PWEBCONTACT_SELECT' ).'</option>';
		foreach ($rows as $row) {
			if (empty($row)) continue;
			$recipient = explode('|', $row);
			$html .= '<option value="'.$i.'">'.$recipient[1].'</option>';
			$i++;
		}
		$html .= '</select>';
		
		return $html;
	}
	
	
	public static function getHiddenFields() 
	{
		$doc 	= JFactory::getDocument();
		$user 	= JFactory::getUser();
		$params = self::getParams();
		
		$module_id = (int)$params->get('id');
		
		if (isset($_SERVER['REMOTE_ADDR'])) 
			$ip = $_SERVER['REMOTE_ADDR'];
		elseif (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) 
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		elseif (isset($_SERVER['HTTP_CLIENT_IP'])) 
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		elseif (isset($_SERVER['HTTP_VIA'])) 
			$ip = $_SERVER['HTTP_VIA'];
		else 
			$ip = 'unknown';

		$html = '
		<input type="hidden" name="user_id" value="'.(int)$user->id.'"/>
		<input type="hidden" name="ip" value="'.$ip.'"/>
		<input type="hidden" name="title" value="'.htmlspecialchars($doc->getTitle()).'"/>
		<input type="hidden" name="referrer" value="'.JURI::getInstance()->toString().'"/>
		<input type="hidden" name="mid" value="'.$module_id.'"/>
		<input type="hidden" name="'.JSession::getFormToken().'" value="1" id="pwebcontact'.$module_id.'_token"/>';
		
		if ($params->get('debug')) $html .= '<input type="hidden" name="debug" value="1"/>';
		
		// Community Builder
		$html .= modPWebContactComprofilerHelper::getHiddenField();
		// JoomSocial
		$html .= modPWebContactJomSocialHelper::getHiddenField();
		// SobiPro
		$html .= modPWebContactSobiProHelper::getHiddenField();
		
		
		return $html;
	}
	
	
	protected static function setEmailFields(&$jform, &$params) 
	{
		// Email subject
		$fields['subject'] = $params->get('email_subject', JText::_('MOD_PWEBCONTACT_SUBJECT'));	
		switch ($params->get('email_subject_sfx', 2))
		{
			case 1:
				$fields['subject'] .= ' '.JFactory::getApplication()->getCfg('sitename');
				break;
			case 2:
				$fields['subject'] .= ' '.$jform['title'];
				break;
		}
			
		// Email fields
		$fields['name'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_NAME'), 
						'value' => $jform['name'], 
						'field' => $jform['name'] ? JText::_('MOD_PWEBCONTACT_NAME').': '.$jform['name']."\r\n" : ''
						);
		$fields['email'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_EMAIL'), 
						'value' => $jform['email'],
						'field' => $jform['email'] ? JText::_('MOD_PWEBCONTACT_EMAIL').': '.$jform['email']."\r\n" : ''
						);
		$fields['phone'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_PHONE'), 
						'value' => $jform['phone'],
						'field' => $jform['phone'] ? JText::_('MOD_PWEBCONTACT_PHONE').': '.$jform['phone']."\r\n" : ''
						);
		if ($params->get('email_html')) $jform['message'] = nl2br($jform['message']);
		$fields['message'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_MESSAGE'), 
						'value' => $jform['message'],
						'field' => $jform['message'] ? JText::_('MOD_PWEBCONTACT_MESSAGE').': '."\r\n".$jform['message']."\r\n" : ''
						);
		$fields['title'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_SITENAME'), 
						'value' => $jform['title'],
						'field' => JText::_('MOD_PWEBCONTACT_SITENAME').': '.$jform['title']."\r\n"
						);
		$fields['referrer'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_REFERRER'), 
						'value' => $jform['referrer'],
						'field' => JText::_('MOD_PWEBCONTACT_REFERRER').': '.$jform['referrer']."\r\n"
						);
		$fields['IP'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_IP'), 
						'value' => $jform['ip'],
						'field' => JText::_('MOD_PWEBCONTACT_IP').': '.$jform['ip']."\r\n"
						);
		$fields['agree'] = array(
						'label' => $params->get('agree_label', JText::_('MOD_PWEBCONTACT_AGREE_TO_TERMS')), 
						'value' => JText::_('JYes'),
						'field' => $jform['agree'] ? $params->get('agree_label', JText::_('MOD_PWEBCONTACT_AGREE_TO_TERMS')).': '.JText::_('JYes')."\r\n" : ''
						);
		if ($params->get('attachment_type', 1))
			$fields['attachments'] = array('label' => '', 'value' => array(), 'field' => '');
		else
			$fields['attachments'] = array(
						'label' => JText::_('MOD_PWEBCONTACT_ATTACHMENT'), 
						'value' => $jform['attachments'],
						'field' => JText::_('MOD_PWEBCONTACT_ATTACHMENT').': '."\r\n".implode("\r\n", $jform['attachments'])."\r\n"
						);
		
		for ($i = 1; $i <= 9; $i++) {
			if ($params->get('email_html') AND $params->get('field_'.$i.'_type') == 'textarea') $jform['field_'.$i] = nl2br($jform['field_'.$i]);
			$fields[$i] = array(
						'label' => $params->get( 'field_'.$i.'_label' ), 
						'value' => $jform['field_'.$i], 
						'field' => $jform['field_'.$i] ? $params->get( 'field_'.$i.'_label' ).': '.$jform['field_'.$i]."\r\n" : ''
						);
		}
						
		return $fields;
	}
	
	
	public static function submit() 
	{
		$app 	= JFactory::getApplication();
		$params = self::getParams();
		
		$module_id = (int)$params->get('id');
		
		// Check token
		if (!JSession::checkToken()) {
			if (PWEBCONTACT_DEBUG) JLog::add('Invalid token', JLog::ERROR, 'mod_pwebcontact');
			// Invalid Token
			return array('status' => 3, 'msg' => JText::_('MOD_PWEBCONTACT_MAIL_ALREADY_SENT'), 'debug' => 'Invalid token');
		}

		// Get inputs
		$jform = $app->input->getArray(array(
			'name' 			=> '',
			'email' 		=> '',
			'phone' 		=> '',
			'message' 		=> '',
			'title' 		=> '',
			'referrer' 		=> '',
			'ip' 			=> '',
			'agree' 		=> 'int',
			'user_id' 		=> 'int',
			'attachments' 	=> ''
		));
		
		if (!is_array($jform['attachments']))
			$jform['attachments'] = explode(',', urldecode($jform['attachments']));
		
		for ($i = 1; $i <= 9; $i++)
			$jform['field_'.$i] = strip_tags(implode(', ', $app->input->get('field_'.$i, array(), 'array')));

		$mailto	= $app->input->getInt('mailto', -1);
		
		// Validate inputs
		jimport('joomla.mail.helper');
		if ( ($params->get('show_message', 1) AND $params->get('require_message', 1) AND !$jform['message']) 
			OR ($params->get('show_email', 1) AND (($jform['email'] AND JMailHelper::isEmailAddress($jform['email']) == false) 
			OR ($params->get('require_email', 1) AND !$jform['email']))) 
		) {
			if (PWEBCONTACT_DEBUG) JLog::add('Invalid input message or email', JLog::ERROR, 'mod_pwebcontact');
			
			return array('status' => 2, 'msg' => JText::_('MOD_PWEBCONTACT_MAIL_DATA_ERROR'), 'debug' => 'Validation error');
		}
		
		// mail from
		$fromname = $app->getCfg('fromname', $app->getCfg('sitename'));
		$mailfrom = $app->getCfg('mailfrom');
		if ( $params->get('debug') AND !$mailfrom ) {
			if (PWEBCONTACT_DEBUG) JLog::add('Mail from not set in Joomla Global Configuration', JLog::ERROR, 'mod_pwebcontact');
			
			return array('status' => 3, 'msg' => JText::_('MOD_PWEBCONTACT_GLOBAL_CONFIG_EMAIL'), 'debug' => 'Mail from not set in Joomla Global Configuration');
		}
		
		// email recipient
		$email_to = array();
		
		
		// Community Builder
		if ( $params->get('comprofiler') AND ($profile_id = $app->input->getInt('comprofiler', 0)) > 0 ) {
			$email = modPWebContactComprofilerHelper::getEmail($profile_id);
			if ($email === false) {
				return array('status' => 4, 'msg' => JText::_('MOD_PWEBCONTACT_NO_TARGET_EMAIL'), 'debug' => 'No email in Community Builder profile');
			} else {
				$email_to[] = $email;
			}
		} 
		// JomSocial
		elseif ( $params->get('jomsocial') AND ($profile_id = $app->input->getInt('jomsocial', 0)) > 0 ) {
			$email = modPWebContactJomSocialHelper::getEmail($profile_id);
			if ($email === false) {
				return array('status' => 4, 'msg' => JText::_('MOD_PWEBCONTACT_NO_TARGET_EMAIL'), 'debug' => 'No email in JomSocial profile');
			} else {
				$email_to[] = $email;
			}
		} 
		// SobiPro
		elseif ( $params->get('sobipro') AND ($entry_id = $app->input->getInt('sobipro', 0)) > 0 ) {
			$email = modPWebContactSobiProHelper::getEmail($entry_id);
			if ($email === false) {
				return array('status' => 4, 'msg' => JText::_('MOD_PWEBCONTACT_NO_TARGET_EMAIL'), 'debug' => 'No email in SobiPro entry');
			} else {
				$email_to[] = $email;
			}
		}
		// Joomla
		else {
			if ( $params->get('email_to') ) {
				$email_to = explode(',', $params->get('email_to'));
			}
			if ( $params->get('email_to_list') AND $mailto > -1 ) {
				$rows = explode("\n", $params->get('email_to_list'));
				if (array_key_exists($mailto, $rows)) {
					$row = explode('|', $rows[$mailto]);
					if ($row[0]) $email_to[] = $row[0];
				}
			}
			if ( $params->get('email_user') ) {
				//j1.6
				$db = JFactory::getDBO();
				$query = $db->getQuery(true);
				$query->select('email');
				$query->from('#__users');
				$query->where('id = '.(int)$params->get('email_user'));
				$db->setQuery($query);
				$email_to[] = $db->loadResult();
			}
		}
		if ( !$mailfrom ) {
			if (array_key_exists(0, $email_to)) {
				$mailfrom = $email_to[0];
			} else {
				return array('status' => 3, 'msg' => JText::_('MOD_PWEBCONTACT_GLOBAL_CONFIG_EMAIL'), 'debug' => 'Mail from not set in Joomla Global Configuration');
			}
		}
		if (count($email_to) == 0) {
			$email_to[] = $mailfrom;
		}
		
		// RTL
		$rtl = (bool) $params->get('rtl', 0);
		
		// HTML email
		$isHTML = (bool) $params->get( 'email_html', 0);
		
		$success_msg = str_replace(array('"','\\'), '', $params->get('msg_success', JText::_('MOD_PWEBCONTACT_MAIL_SUCCESS')));
		
		// ticket
		$ticket = '';
		if ($ticket_type = $params->get('ticket_enable', 0)) 
		{
			if ($ticket_type == 1)
			{
				$date = JFactory::getDate()->toFormat('%Y%m%d%H%M%S');
				$ticket = sprintf($params->get('ticket_format', '[#%s]'), $date).' ';
			}
			elseif ($ticket_type == 2)
			{
				$ticket_file = $params->get('media_path').'tickets/ticket_'.sprintf('%03d', $module_id).'.txt';
				$ticket_counter = JFile::exists($ticket_file) ? (int)JFile::read($ticket_file) : 0;
				$ticket_counter++;
				JFile::write($ticket_file, $ticket_counter);
				$ticket = sprintf($params->get('ticket_format', '[#%06d]'), $ticket_counter).' ';
			}
			$success_msg = sprintf($success_msg, $ticket);
		}
		
		// atachments
		if (count($jform['attachments'])) 
		{
			if ($params->get('attachment_type', 1))
			{
				// absolute path
				$path = $params->get('upload_path');
				$attachments = array('paths' => array(), 'files' => array());
				foreach ($jform['attachments'] as $key => $file) {
					$attachments['paths'][$key] = $path . $file;
					$attachments['files'][$key] = $file;
				}
			}
			else
			{
				// absolute URL
				$url = $params->get('media_url').'upload/'.$module_id.'/';
				foreach ($jform['attachments'] as &$file) {
					$file = $url . rawurlencode($file);
				}
			}
		}
		
		$tmpl_path = $params->get('media_path').'email_tmpl/';
		
		// User email
		if ( $params->get( 'email_copy', 0) AND $app->input->getInt( 'copy', 0 ) AND $params->get('show_email', 1) AND $jform['email'] ) 
		{
			// load email template fields
			$fields = modPWebContactHelper::setEmailFields($jform, $params);
			
			$mail = JFactory::getMailer();
			if (PWEBCONTACT_DEBUG) JLog::add('User email started', JLog::INFO, 'mod_pwebcontact');
			
			// set sender
			$mail->setSender( array( $mailfrom, $fromname ) );
			if (PWEBCONTACT_DEBUG) JLog::add('Sender set: '.$mailfrom, JLog::INFO, 'mod_pwebcontact');
			
			// set reply to
			if ($params->get( 'email_replyto')) 
			{
				$replyto_email = $params->get( 'email_replyto', $mailfrom);
				$mail->ClearReplyTos();
				$mail->addReplyTo( $replyto_email, $params->get( 'email_replyto_name', $fromname) );
				if (PWEBCONTACT_DEBUG) JLog::add('Reply to set: '.$replyto_email, JLog::INFO, 'mod_pwebcontact');
			}
			
			// add recipient
			$mail->addRecipient( $jform['email'] );
			if (PWEBCONTACT_DEBUG) JLog::add('Recipient set: '.$jform['email'], JLog::INFO, 'mod_pwebcontact');
			
			// set subject
			$subject = $ticket . $fields['subject'];
			$mail->setSubject( $subject );
			if (PWEBCONTACT_DEBUG) JLog::add('Subject set: '.$subject, JLog::INFO, 'mod_pwebcontact');
			
			
			// set attachments as files
			if (isset($attachments))
			{
				if (version_compare(JVERSION, '3.0.0') == -1) {
					foreach ($attachments['files'] as $key => $file)
						$mail->addAttachment($attachments['paths'][$key], $file);
				} else {
					$mail->addAttachment($attachments['paths'], $attachments['files']);
				}
				if (PWEBCONTACT_DEBUG) JLog::add('Added attachments: '.implode(', ', $attachments['files']), JLog::INFO, 'mod_pwebcontact');
			}
			
			// load email body template
			$mail->IsHTML((bool)$isHTML);
			$tmpl_file = 'user'.$module_id.'_'.($isHTML ? 'html' : 'text').'.php';
			if (file_exists($tmpl_path.$tmpl_file)) {
				include $tmpl_path.$tmpl_file;
			} else {
				include $tmpl_path.'user_'.($isHTML ? 'html' : 'text').'.php';
			}
			// set body text direction
			$body = ($rtl ? "\xE2\x80\x8F" : "\xE2\x80\x8E") . $body;
			
			// set body text
			$mail->setBody( $body );
			
			if (PWEBCONTACT_DEBUG) JLog::add('User email prepared', JLog::INFO, 'mod_pwebcontact');
	
			// send User email
			if ( $mail->Send() !== true ) 
			{
				if (PWEBCONTACT_DEBUG) JLog::add('User email NOT send', JLog::ERROR, 'mod_pwebcontact');
				return array('status' => 3, 'msg' => JText::_('MOD_PWEBCONTACT_MAIL_ERROR'), 'debug' => 'Error sending email to User');
			} 
			elseif (PWEBCONTACT_DEBUG) JLog::add('User email sent successful', JLog::INFO, 'mod_pwebcontact');
		}
		
		// Demo: do not send email to Admin
		if ($params->get('demo', 0)) return array('status' => 1, 'msg' => $success_msg, 'debug' => '');
		
		// Administrator email language
		$email_lang = $params->get('email_lang');
		if ($email_lang) {
			$lang = JFactory::getLanguage();
			$lang_previous = $lang->getTag();
			if ($email_lang != $lang_previous) {
				$lang->setLanguage($email_lang);
				$lang->load('mod_pwebcontact');
				
				if ($rtl != $lang->isRTL()) {
					$rtl = $lang->isRTL();
					$params->set('rtl', (int) $rtl);
				}
				$fields = modPWebContactHelper::setEmailFields($jform, $params);
				
				if (PWEBCONTACT_DEBUG) JLog::add('Administrator email language prepared', JLog::INFO, 'mod_pwebcontact');
			}
			elseif (PWEBCONTACT_DEBUG) JLog::add('Administrator email language was not changed', JLog::INFO, 'mod_pwebcontact');
		}
		if (!isset($fields)) {
			$fields = modPWebContactHelper::setEmailFields($jform, $params);
		}
		
		// Administrator email
		$mail = JFactory::getMailer();
		if (PWEBCONTACT_DEBUG) JLog::add('Administrator email started', JLog::INFO, 'mod_pwebcontact');

		// set sender
		if ($params->get('show_email', 1) AND $jform['email'] AND !$params->get('server_sender', 0)) {
			$mail->setSender( array( $jform['email'], $jform['name'] ) );
			if (PWEBCONTACT_DEBUG) JLog::add('Sender set: '.$jform['email'], JLog::INFO, 'mod_pwebcontact');
		} else {
			$mail->setSender( array( $mailfrom, $fromname ) );
			if (PWEBCONTACT_DEBUG) JLog::add('Sender set: '.$mailfrom, JLog::INFO, 'mod_pwebcontact');
		}
		
		// add reply to
		if ($params->get('show_email', 1) AND $jform['email']) {
			$mail->ClearReplyTos();
			$mail->addReplyTo( array( $jform['email'], $jform['name'] ) );
			if (PWEBCONTACT_DEBUG) JLog::add('Reply to set: '.$jform['email'], JLog::INFO, 'mod_pwebcontact');
		}
		
		// add recipient
		$mail->addRecipient( $email_to );
		if (PWEBCONTACT_DEBUG) JLog::add('Recipients set: '.(is_array($email_to) ? implode(', ', $email_to) : $email_to), JLog::INFO, 'mod_pwebcontact');
		
		// add blind carbon recipient
		if ($params->get('email_bcc')) {
			$email_bcc = explode(',', $params->get('email_bcc'));
			$mail->addBCC($email_bcc);
			if (PWEBCONTACT_DEBUG) JLog::add('BCC recipients added', JLog::INFO, 'mod_pwebcontact');
		}
		
		// set subject
		$subject = $ticket . $fields['subject'];
		$mail->setSubject( $subject );
		if (PWEBCONTACT_DEBUG) JLog::add('Subject set: '.$subject, JLog::INFO, 'mod_pwebcontact');
		
		// set attachments as files
		if (isset($attachments))
		{
			if (version_compare(JVERSION, '3.0.0') == -1) {
				foreach ($attachments['files'] as $key => $file)
					$mail->addAttachment($attachments['paths'][$key], $file);
			} else {
				$mail->addAttachment($attachments['paths'], $attachments['files']);
			}
			if (PWEBCONTACT_DEBUG) JLog::add('Added attachments: '.implode(', ', $attachments['files']), JLog::INFO, 'mod_pwebcontact');
		}
		
		// load email body template
		$mail->IsHTML((bool)$isHTML);
		$tmpl_file = 'admin'.$module_id.'_'.($isHTML ? 'html' : 'text').'.php';
		if (file_exists($tmpl_path.$tmpl_file)) {
			include $tmpl_path.$tmpl_file;
		} else {
			include $tmpl_path.'admin_'.($isHTML ? 'html' : 'text').'.php';
		}
		// set body text direction
		$body = ($rtl ? "\xE2\x80\x8F" : "\xE2\x80\x8E") . $body;
		
		// set body text
		$mail->setBody( $body );
		
		if (PWEBCONTACT_DEBUG) JLog::add('Administrator email prepared', JLog::INFO, 'mod_pwebcontact');
		
		// send Admin email
		if ( $mail->Send() === true ) {
			if (PWEBCONTACT_DEBUG) JLog::add('Administrator email sent successful', JLog::INFO, 'mod_pwebcontact');
			return array('status' => 1, 'msg' => $success_msg, 'debug' => '');
		} else {
			if (PWEBCONTACT_DEBUG) JLog::add('Administrator email NOT send', JLog::ERROR, 'mod_pwebcontact');
		}
		
		return array('status' => 3, 'msg' => JText::_('MOD_PWEBCONTACT_MAIL_ERROR'), 'debug' => 'Error sending email to Admin');
	}
}
