<?php
/**
* @version 2.3.4
* @package PWebContact
* @copyright © 2012 Majestic Media sp. z o.o., All rights reserved. http://www.perfect-web.co
* @license GNU General Public Licence http://www.gnu.org/licenses/gpl-3.0.html
* @author Piotr Moćko
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (dirname(__FILE__).'/helpers/helper.php');

$app = JFactory::getApplication();

$params->def('id', $module->id);
if ($app->getCfg('debug') OR $app->input->getInt('debug')) $params->set('debug', 1);

// Community Builder
if ($params->get('comprofiler') AND $params->get('comprofiler_userprofile')) {
	if (!modPWebContactComprofilerHelper::isUserProfileView()) return;
}
// JomSocial
elseif ($params->get('jomsocial') AND $params->get('jomsocial_userprofile')) {
	if (!modPWebContactJomSocialHelper::isUserProfileView()) return;
}
// SobiPro
elseif ($params->get('sobipro') AND $params->get('sobipro_entry')) {
	if (!modPWebContactSobiProHelper::isEntryView()) return;
}

$doc	= JFactory::getDocument();
$user 	= JFactory::getUser();

JHTML::_('behavior.formvalidation');
JHTML::_('behavior.tooltip');

// Auto RTL
$lang = JFactory::getLanguage();
if ($params->get('rtl', 2) == 2) {
	if ($lang->isRTL())
		$params->set('rtl', 1);
	else
		$params->set('rtl', 0);
}

// Layout
$layout = explode('.', $params->get('layout', 'default.default-left'));
$params->set('layout', $layout[0]);
$params->set('layout_type', $layout[1]);

if ($app->input->get('tmpl') == 'component' AND $layout[0] != 'static') return;

// Set media path
$media_path = JPATH_ROOT.'/media/mod_pwebcontact/';
$params->set('media_path', $media_path);
$media_url = JURI::base(true).'/media/mod_pwebcontact/';
$params->set('media_url', $media_url);

// Choose layout
switch($layout[0]) {
	case 'modal':
		$css['general'] = $layout[1].'.css';
		$css['style'] = $params->get('style_modal', 'blue').'.css';
		JHTML::_('behavior.modal');
		break;
	case 'static':
		$css['general'] = $layout[1].'.css';
		$css['style'] = $params->get('style_static', 'light').'.css';
		break;
	default:
		$layout[0] = 'default';
		$css['general'] = $layout[1].'.css';
		$css['style'] = $params->get('style_default', 'dark').'.css';
}

// CSS
$doc->addStyleSheet($media_url.'css/general/'.$css['general']);
if ($params->get('rtl', 0)) {
	// RTL CSS
	$doc->addStyleSheet($media_url.'css/general/rtl/'.$css['general']);
}
$doc->addStyleSheet($media_url.'css/'.$layout[0].'/'.$css['style']);

// IE CSS
if (!defined('MOD_PWEBCONTACT_IE')) {
	define('MOD_PWEBCONTACT_IE', 1);
	$doc->addCustomTag(
		 '<!--[if IE 9]>'."\r\n"
		.'<link rel="stylesheet" href="'.$media_url.'css/general/ie9.css" />'."\r\n"
		.'<![endif]-->'."\r\n"
		.'<!--[if lte IE 8]>'."\r\n"
		.'<link rel="stylesheet" href="'.$media_url.'css/general/ie.css" />'."\r\n"
		.'<![endif]-->'."\r\n"
		.'<!--[if IE 8]>'."\r\n"
		.'<link rel="stylesheet" href="'.$media_url.'css/general/ie8.css" />'."\r\n"
		.'<![endif]-->'."\r\n"
	);
}

// Set params
modPWebContactHelper::setParams($params);

// JS
modPWebContactHelper::addAnalyticsScript();

$styles = modPWebContactHelper::getTemplateStyles();

require(JModuleHelper::getLayoutPath('mod_pwebcontact', '_:'.$layout[0]));
