<?php
/**
* Module mod_resp_animate_hover For Joomla 2.5.x/3.0.X
* Version		: 2.0
* Created by	: Daniel Pardons
* Email			: daniel.pardons@joompad.be
* Created on	: 21 April 2013
* Last Modified : 21 April 2013
* URL			: www.joompad.be
* Copyright (C) 2010 - 2013 Daniel Pardons
* License GPLv2.0 - http://www.gnu.org/licenses/gpl-2.0.html
* Based on Animate a hover with jQuery Timothy van Sas tutorial (http://www.incg.nl/blog/2008/hover-block-jquery/

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');


//Find content link.

class ModResp_animate_hoverHelper 
{	

	/**
	 * get the list of all images defined in module parameters
	 * 
	 * @return Array of file names
	 */

    function getListFromModule(&$params) {
		// module static basic parameters
		$mod_max_img = 20; // max nr of images to be processed (a max of 20 images can be defined in module parameters)
	
		$external_url	= $params->get( 'external_url' );
		$folder			= $params->get( 'folder' );
		if (empty($external_url)) {
			$folder 	= JURI::base().$folder;
		} else {
			$folder	= $external_url;
		}

		$gallery_sorting = $params->get( 'gallery_sorting' );
		$image_color_target = $params->get( 'image_color_target' );
		$teaser_bgcolor = $params->get( 'teaser_bgcolor' );
		$title_color	= $params->get( 'title_color' );
		$teaser_color	= $params->get( 'teaser_color' );
		
		// initialize working arrays
		$image_ref = array();
		$image_img = array();
		$box_type = array();
		$image_bg_color = array();
		$image_title_color = array();
		$image_teaser_color = array();
		$image_alt = array();
		$image_title = array();
		$image_teaser = array();
		$image_url = array();
		$target_url = array();

		$image_url_artid = array();
		$image_url_artid_pos = array();

		for ($i = 1; $i <= $mod_max_img; $i++) {
			if ( $params->get( 'image_img'.$i ) || $params->get( 'box_type'.$i )== 'caption' ) {
				$image_ref[]	= $i;
				$image_img[$i] 	= $folder.trim($params->get( 'image_img'.$i ));
				$box_type[$i] = $params->get( 'box_type'.$i ) ;
				$image_alt[$i] 	= $params->get( 'image_alt'.$i );
				switch ($image_color_target) {
					case 3: 
						$image_bg_color[$i] = $teaser_bgcolor;				
						$image_title_color[$i] = ($params->get( 'image_teaser_bgcolor'.$i )) ? $params->get( 'image_teaser_bgcolor'.$i ) : $title_color;
						$image_teaser_color[$i] = ($params->get( 'image_teaser_bgcolor'.$i )) ? $params->get( 'image_teaser_bgcolor'.$i ) : $teaser_color;
						break;
					case 2: 
						$image_bg_color[$i] = $teaser_bgcolor;				
						$image_title_color[$i] = $title_color;
						$image_teaser_color[$i] = ($params->get( 'image_teaser_bgcolor'.$i )) ? $params->get( 'image_teaser_bgcolor'.$i ) : $teaser_color;
						break;
					case 1: 
						$image_bg_color[$i] = $teaser_bgcolor;				
						$image_title_color[$i] = ($params->get( 'image_teaser_bgcolor'.$i )) ? $params->get( 'image_teaser_bgcolor'.$i ) : $title_color;
						$image_teaser_color[$i] = $teaser_color;
						break;
					case 0:
					default:
						$image_bg_color[$i] = ($params->get( 'image_teaser_bgcolor'.$i )) ? $params->get( 'image_teaser_bgcolor'.$i ) : $teaser_bgcolor;				
						$image_title_color[$i] = $title_color;
						$image_teaser_color[$i] = $teaser_color;
				}

				$image_title[$i] 	= $params->get( 'image_title'.$i );
				$image_teaser[$i] 	= ($params->get( 'teaser_nl2br' )) ? nl2br($params->get( 'image_teaser'.$i ),true) : $params->get( 'image_teaser'.$i );
		// check if url parameter references an article/k2 itemid or a blank/relative/full url 
				$image_url[$i] 	= str_replace('&', '&amp;', $params->get( 'image_url'.$i ));
				if ( (int)$image_url[$i] == $image_url[$i] && (int)$image_url[$i]  > 0 ) {
					$image_url_artid[] = $image_url[$i];
					$image_url_artid_pos[] = $i;
				} 
				$target_url[$i] 	= $params->get( 'target_url'.$i );
			}
		}
		// replace url article id by article sef url if needed
		$image_url_artid_cnt = count ($image_url_artid);

		// if some artid/K2itemid are defined in the image url module parameter, load sef utilities files and start process to convert artid/K2itemid in sef url
		if ($image_url_artid_cnt) {
			if ($params->get( 'url_id_target') ) {
				$urls = ModResp_animate_hoverHelper::getk2ArticlesUrl ($image_url_artid);		
			} else {
				$urls = ModResp_animate_hoverHelper::getArticlesUrl ($image_url_artid);
			}
			$urls_cnt = count ($urls);
		// check if all art ids have been converted to urls (duplicate artid or non existent artid) and replace missing url for duplicate artids by url associated to the first artid
		// create array with artids not converted to url (contains "")
			$missing_urls = array_keys($urls,""); 
			for ($j = 0; $j < count ($missing_urls); $j++) {
				$missing_artid = $image_url_artid[$missing_urls[$j]];
				// find the key of the same artid if existing in the array 
				$equivalent_artid = array_search ($missing_artid, $image_url_artid);
				if ($equivalent_artid !== false) {
					$urls[$missing_urls[$j]] = $urls[$equivalent_artid];
				}
			}
		// set urls associated to artid in the base $image_url array	
			for ($i = 0; $i < $image_url_artid_cnt; $i++) {
				$image_url[$image_url_artid_pos[$i]] = $urls[$i];
			}
		}
		$image_cnt = count ($image_ref);
		if ($gallery_sorting ) {
			shuffle ($image_ref);
		}

		// init return object 
	
		$imagenr = 0;
		for ($i= 1; $i <= $image_cnt; $i++) {
			$cur_img = $image_ref[$imagenr] ;
			$slides[] = (object) array(
				'position'=>$cur_img,
				'name'=>$image_img[$cur_img],
				'box_type'=>$box_type[$cur_img],
				'bg_color'=>$image_bg_color[$cur_img],
				'title_color'=>$image_title_color[$cur_img],
				'teaser_color'=>$image_teaser_color[$cur_img],
				'title'=>$image_title[$cur_img],
				'description'=>$image_teaser[$cur_img],
				'link'=>$image_url[$cur_img],
				'alt'=>$image_alt[$cur_img],
				'target'=>$target_url[$cur_img]
			);		
		$imagenr++;
		}	
				
		return $slides;

	}
	
	/**
	 * get the urls of the list of articles
	 * 
	 * @param $ids Array;
	 * @return Array
	 */
	function getArticlesUrl ($ids)
	{
		//Load content route helper
		require_once JPATH_SITE.'/components/com_content/helpers/route.php';
		$urls = array_fill (0, count ($ids), ""); // initialise urls to ""	

		global $mainframe;
		$user 	= JFactory::getUser();
		$db	    = JFactory::getDBO();
		$date   = JFactory::getDate();
		$now    = $date->toSQL();
        $nullDate = $db->getNullDate();
		$authorised = JAccess::getAuthorisedViewLevels($user->get('id'));

		// make sql query
		$query 	= 'SELECT a.id, a.access, a.alias, cc.alias as catalias, cc.description as catdesc, cc.title as cattitle, cc.access as cataccess' 
				. "\n FROM #__content AS a"
				. ' LEFT JOIN #__categories AS cc ON cc.id = a.catid' 
				. "\n WHERE a.state = 1"
				. "\n AND ( a.publish_up = " . $db->Quote($nullDate) . " OR a.publish_up <= " . $db->Quote( $now  ) . " )"
				. "\n AND ( a.publish_down = " . $db->Quote($nullDate) . " OR a.publish_down >= " . $db->Quote( $now  ) . " )"
				. " AND cc.published = 1" 
				;
		$query .= '  AND a.id IN ("'. implode( '","', $ids ) .'") ';
		$db->setQuery($query);
		$data = $db->loadObjectlist();
		if( empty($data) ) return $urls;

		foreach( $data as $key => $item ){	
			$index = array_search ($data[$key]->id, $ids);
			$item->slug = $item->id.':'.$item->alias;
			$item->catslug = $item->catid ? $item->catid.':'.$item->catalias : $item->catid;

			// authorise
			if (in_array($item->access, $authorised) 
				&& in_array($item->cataccess, $authorised)) {
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->id, $item->catslug));
			} else {
				$item->link = JRoute::_('index.php?option=com_user&view=login');
			}
			$urls[$index] = $item->link;
		}
		return $urls;	
	}
	

	/**
	 * get the urls of the list of k2articles
	 * 
	 * @param $ids Array;
	 * @return Array
	 */
	function getk2ArticlesUrl ($ids)
	{
		$urls = array_fill (0, count ($ids), ""); // initialise urls to ""
		if( !self::isK2Existed() ){
			return $urls;
		} 
		return self::getk2ListUrl( $ids );
	}
		
	/**
	 * check K2 Existed ?
	 */
	 function isK2Existed(){
		return is_file( JPATH_SITE.DS.  "components" . DS . "com_k2" . DS . "k2.php" );	
	}		
		

	/**
	 * get the urls of the list of k2articles
	 * 
	 * @param $ids Array;
	 * @return Array
	 */		
		
	 function getk2ListUrl( $ids ){		
		//Load K2 content route helper
		require_once ( JPath::clean(JPATH_SITE.'/components/com_k2/helpers/route.php') );

		$urls = array_fill (0, count ($ids), ""); // initialise urls to ""
		
		global $mainframe;
		$user 	= JFactory::getUser();
		$db	    = JFactory::getDBO();
		$date   = JFactory::getDate();
		$now    = $date->toSQL();
        $nullDate = $db->getNullDate();
		$authorised = JAccess::getAuthorisedViewLevels($user->get('id'));
		
		// make sql query
		$query = "SELECT a.*, c.name as categoryname, c.id as categoryid, c.alias as categoryalias, c.access as categoryaccess, c.params as categoryparams"
				. "\n FROM #__k2_items AS a"
				. ' LEFT JOIN #__k2_categories AS c ON c.id = a.catid';
			
		$query .= " WHERE a.published = 1"
					. " AND a.trash = 0"
					. " AND a.trash = 0" 
					. " AND c.published = 1" 
					. " AND c.trash = 0 "
					;	

        $query .= " AND ( a.publish_up = " . $db->Quote($nullDate) . " OR a.publish_up <= " . $db->Quote($now) . " )";
        $query .= " AND ( a.publish_down = " . $db->Quote($nullDate) . " OR a.publish_down >= " . $db->Quote($now) . " )";

		$query .= '  AND a.id IN("'. implode( '","', $ids ) .'") ';			

		$db->setQuery($query);
		$data = $db->loadObjectlist();

		if( empty($data) ) return $urls;
	
		foreach( $data as $key => $item ){	
			$index = array_search ($data[$key]->id, $ids);

			// authorise
 			if (in_array($item->access, $authorised) 
				&& in_array($item->categoryaccess, $authorised)) {
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(K2HelperRoute::getItemRoute($item->id . ':' . $item->alias, $item->catid . ':' . $item->categoryalias));
            } else {
                $item->link = JRoute::_('index.php?option=com_user&view=login');
            }			
			$urls[$index] = $item->link;
		}
		return $urls;
	}
		
}