<?php
/**
* Module mod_slidingcaptions For Joomla 2.5
* Version		: 1.4.6
* Created by	: Daniel Pardons
* Email			: daniel.pardons@joompad.be
* Created on	: 04 Mar 2011
* Last Modified : 2013/08/04
* URL			: www.joompad.be
* Copyright (C) 2011-2013  Daniel Pardons
* License GPLv2.0 - http://www.gnu.org/licenses/gpl-2.0.html
*
* Based on jQuery Sam Dunn tutorial "Sliding Boxes and Captions with jQuery" 
* http://buildinternet.com/2009/03/sliding-boxes-and-captions-with-jquery/)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

$baseurl 		= JURI::base();
$module_id		= $params->get( 'module_id' );

$folder			= $params->get( 'folder' );
$gallery_position = $params->get( 'gallery_position' );
$gallery_left_margin = (int)$params->get( 'gallery_left_margin' );
$gallery_top_margin = $params->get( 'gallery_top_margin' );
$gallery_bottom_margin = $params->get( 'gallery_bottom_margin' );
$gallery_width	= (int)$params->get( 'gallery_width' );
//$gallery_rows = (int)$params->get( 'gallery_rows' );
$images_in_row = (int)$params->get( 'images_in_row' );
$gallery_bgcolor= $params->get( 'gallery_bgcolor' );
$gallery_css = $params->get( 'gallery_css' );

$image_width	= (int)$params->get( 'image_width' );
$image_height	= (int)$params->get( 'image_height' );
$image_margin	= (int)$params->get( 'image_margin' );
$image_css		= $params->get( 'image_css' );

$boxcaption_css	= $params->get( 'boxcaption_css' );
$caption_min_height = (int)$params->get( 'caption_min_height' );
$caption_max_height = (int)$params->get( 'caption_max_height' );
$caption_initial_height = $image_height - $caption_min_height;
$caption_final_height = $image_height - $caption_max_height;
$caption_bgcolor = $params->get( 'caption_bgcolor' );
$caption_opacity = $params->get( 'caption_opacity' );
$caption_ie_opacity = (int)($caption_opacity*100);
$caption_sliding_duration =  $params->get( 'caption_sliding_duration' );
$gallery_images_use = $params->get( 'gallery_images_use','0' );

$url_link_type	= $params->get( 'url_link_type' );
$readmore_text	= $params->get( 'readmore_text' );
$url_text_css	= $params->get( 'url_text_css' );
$url_text_act_css =  $params->get( 'url_text_act_css' );
$url_icon_css	= $params->get( 'url_icon_css' );
$icon_file_path = $params->get( 'icon_file_path' );

$title_color	= $params->get( 'title_color' );
$title_css		= $params->get( 'title_css' );
$teaser_color	= $params->get( 'teaser_color' );
$teaser_css		= $params->get( 'teaser_css' );

$image_img = array();
$image_caption_color = array();
$image_alt = array();
$image_url = array();
$image_title = array();
$image_teaser = array();
$target_url= array();

$max_images = 20;

for ($i = 1; $i <= $max_images; $i++) {
	if ($params->get( 'image_img'.$i )) {
		$image_ref[]	= $i;
		$image_img[$i] 	= $baseurl.$folder.trim($params->get( 'image_img'.$i ));
		$image_caption_color[$i] = ($params->get( 'image_img'.$i.'_caption_bgcolor' )) ? $params->get( 'image_img'.$i.'_caption_bgcolor' ) : $caption_bgcolor;
		$image_alt[$i] 	= $params->get( 'image_alt'.$i );
		$image_title[$i] 	= $params->get( 'image_title'.$i );
		if ($image_alt[$i] == '') {
			$image_alt[$i] = (!$image_title[$i] == '') ? $image_title[$i] : '';
		}
		$image_teaser[$i] 	= ($params->get( 'teaser_nl2br' )) ? nl2br($params->get( 'image_teaser'.$i )) : $params->get( 'image_teaser'.$i );
		$image_url[$i] 	= str_replace('&', '&amp;', $params->get( 'image_url'.$i ));
		$target_url[$i] 	= $params->get( 'target_url'.$i );
	}
}

$image_cnt = count ($image_ref);
if ($gallery_images_use ) {
	shuffle ($image_ref);
}
$gallery_rows = ceil ($image_cnt / $images_in_row); //actual nr of rows
//$gallery_width	= (int)$params->get( '$gallery_width' );

$gallery_width_calc =  ($images_in_row * $image_width) + (($images_in_row + 1) * $image_margin);
if  (!$gallery_width) {
	if ($gallery_position) {
		$gallery_width = $gallery_width_calc;
	} else {
		$gallery_width = $gallery_width_calc + $gallery_left_margin;
	}
}

$document =& JFactory::getDocument();
if ($params->get('load_JQuery')==1)  {
	$document->addScript(JURI::base() . 'modules/mod_slidingcaptions/js/jquery-1.4.2.min.js');
}

$sccs='';
if ($gallery_position == 1) {
	$sccs .= '
	#scgallery'.$module_id.' {
		margin-left: auto;
		margin-right: auto;
		width: '.$gallery_width.'px;
		margin-top: '.$gallery_top_margin.'px !important;
		margin-bottom: '.$gallery_bottom_margin.'px !important;
		background: '.$gallery_bgcolor.' !important;
		'.$gallery_css.'
		display: block;
		overflow: hidden;
	}';
} else {
	$sccs .= '
	#scgallery'.$module_id.' {
		margin-left: '.$gallery_left_margin.'px;
		margin-top: '.$gallery_top_margin.'px !important;
		margin-bottom: '.$gallery_bottom_margin.'px !important;
		width: '.$gallery_width.'px;
		background: '.$gallery_bgcolor.' !important;
		'.$gallery_css.'
		display: block;
		overflow: hidden;
	}';
}
$sccs .= '
	#scgallery'.$module_id.' .boxgrid  {
		width: '.$image_width.'px;
		height: '.$image_height.'px;
		margin-top: '.$image_margin.'px;
		margin-left: '.$image_margin.'px;
		'.$image_css.'
		float: left;
		overflow: hidden;
		position: relative;
	}';
$sccs .= '
	#scgallery'.$module_id.' .boxgrid_bottom  {
		margin-bottom: '.$image_margin.'px;
	}';
$sccs .= '
	#scgallery'.$module_id.' .boxgrid img {
		position: absolute;
		top: 0;
		left: 0;
		border: 0;
	}';
$sccs .= '
	#scgallery'.$module_id.' .boxgrid  .teaser-title {
		color: '.$title_color.';
		'.$title_css.'
	}';
$sccs .= '
	#scgallery'.$module_id.' .boxgrid .teaser-text {
		color: '.$teaser_color.';
		'.$teaser_css.'
	}';

$sccs .= '
	#scgallery'.$module_id.' .boxcaption {
		float: left; 
		position: absolute; 
		height: '.$caption_max_height.'px; 
		width: 100%; 
		'.$boxcaption_css.'
	}';

$sccs .= '
	#scgallery'.$module_id.' .captionfull .boxcaption {
 		top: '.$caption_initial_height.'px;
 		left: 0px;
 	}';

$sccs .= '
	#scgallery'.$module_id.' .boxcaption .moreTextLink {
		display:block; 
		'.$url_text_css.'
	}';
$sccs .= '
	#scgallery'.$module_id.' .boxcaption a:hover.moreTextLink {
		'.$url_text_act_css.'
	}';

$icon_fullrelative_filepath = JURI::base(true).$icon_file_path;
$sccs .= '
	#scgallery'.$module_id.' .boxcaption .moreImageLink {
		display:block; 
		text-indent:-9999px; 
		background:url('.$icon_fullrelative_filepath.');
		background-repeat: no-repeat;
		'.$url_icon_css.'
	}';

// put configuration code in the header
$document->addStyleDeclaration($sccs);

?>

<script type="text/javascript">
// set flags for whether we should use opacity or filter with
// this browser (or browser mode). we prefer opacity.
var useOpacity =
   (typeof document.createElement("div").style.opacity != 'undefined');
var useFilter = !useOpacity
   && (typeof document.createElement("div").style.filter != 'undefined');
jQuery.noConflict();
jQuery(document).ready(function($)
{
   if (useOpacity) {
      $('#scgallery<?php echo $module_id; ?> .boxcaption').css('opacity',<?php echo $caption_opacity;?>);
   } else if (useFilter) {
      $('#scgallery<?php echo $module_id; ?> .boxcaption').css('filter',"alpha(opacity=" + (<?php echo $caption_opacity;?> * 100) + ")");
   } else {
   }

	//Full Caption Sliding (Hidden or partially hidden to Visible)
	$('#scgallery<?php echo $module_id; ?> .boxgrid.captionfull').hover(function(){
		$(this).next("img").stop().animate({"backgroundColor" : "#40331b"}, 400);
		$(".cover", this).stop().animate({top:'<?php echo $caption_final_height; ?>px'},{queue:false,duration:<?php echo $caption_sliding_duration; ?>});
	}, function() {
		$(this).next("img").stop().animate({"backgroundColor" : "#79694C"}, 400);
		$(".cover", this).stop().animate({top:'<?php echo $caption_initial_height; ?>px'},{queue:false,duration:<?php echo $caption_sliding_duration; ?>});
	});
});
</script>

<div id="scgallery<?php echo $module_id; ?>">
<?php 
$imagenr = 0;
for ($r = 1; $r <= $gallery_rows; $r++) {;
	 for ($ir= 1; $ir <= $images_in_row; $ir++) { ;
		$cur_img = $image_ref[$imagenr] ;?>
		<?php if ($imagenr < $image_cnt) { ?>
<!--galleryEntry <?php echo $imagenr+1; ?> -->
			<?php if ($image_url[$cur_img] && $url_link_type == 3)  { 
				if ($target_url[$cur_img] == '_self') { ;?>
					<div onclick='window.location.href="<?php echo $image_url[$cur_img]; ?>"' style="cursor:pointer;">
				<?php } else { ;?>
					<div onclick='window.open("<?php echo $image_url[$cur_img]; ?>")' style="cursor:pointer;">
				<?php }
			} ;?>
			<?php if ($r != $gallery_rows) { ;?>
			<div class="boxgrid captionfull">
			<?php } else { ;?>
			<div class="boxgrid captionfull boxgrid_bottom">
			<?php } ;?>
			<?php if ($image_url[$cur_img]) {
				if ($url_link_type == 3)  { ?>					
				<img src="<?php echo $image_img[$cur_img]; ?>" alt="<?php echo $image_alt[$cur_img]; ?>" />
				<div class="cover boxcaption" style="background:<?php echo $image_caption_color[$cur_img]; ?> !important;">
					<div class="teaser-title" style="color:<?php echo $title_color; ?>; <?php echo $title_css; ?>"><?php echo $image_title[$cur_img]; ?></div>
					<div class="teaser-text" style="color:<?php echo $teaser_color; ?>; "><?php echo $image_teaser[$cur_img]; ?></div>
				</div>
			<?php } ?>
			<?php if ($url_link_type == 2)  { ?>
				<img src="<?php echo $image_img[$cur_img]; ?>" alt="<?php echo $image_alt[$cur_img]; ?>" />
				<a  href="<?php echo $image_url[$cur_img]; ?>" target="<?php echo $target_url[$cur_img]; ?>"><?php echo $readmore_text; ?>
					<div class="cover boxcaption" style="background:<?php echo $image_caption_color[$cur_img]; ?> !important;">
						<div class="teaser-title" style="color:<?php echo $title_color; ?>; <?php echo $title_css; ?>"><?php echo $image_title[$cur_img]; ?></div>
						<div class="teaser-text" style="color:<?php echo $teaser_color; ?>; "><?php echo $image_teaser[$cur_img]; ?></div>
					</div>
				</a>
			<?php } ?>
			<?php if ($url_link_type == 1)  { ?>
				<img src="<?php echo $image_img[$cur_img]; ?>" alt="<?php echo $image_alt[$cur_img]; ?>" />
				<div class="cover boxcaption" style="background:<?php echo $image_caption_color[$cur_img]; ?> !important;">
					<div class="teaser-title" style="color:<?php echo $title_color; ?>; <?php echo $title_css; ?>"><?php echo $image_title[$cur_img]; ?></div>
					<div class="teaser-text" style="color:<?php echo $teaser_color; ?>; "><?php echo $image_teaser[$cur_img]; ?></div>
					<a  class="moreImageLink" href="<?php echo $image_url[$cur_img]; ?>" target="<?php echo $target_url[$cur_img]; ?>"><?php echo $readmore_text; ?></a>
				</div>
			<?php } ?>
			<?php if ($url_link_type == 0)  { ?>
				<img src="<?php echo $image_img[$cur_img]; ?>" alt="<?php echo $image_alt[$cur_img]; ?>" />
				<div class="cover boxcaption" style="background:<?php echo $image_caption_color[$cur_img]; ?> !important;">
					<div class="teaser-title" style="color:<?php echo $title_color; ?>; <?php echo $title_css; ?>"><?php echo $image_title[$cur_img]; ?></div>
					<div class="teaser-text" style="color:<?php echo $teaser_color; ?>; "><?php echo $image_teaser[$cur_img]; ?></div>
					<a class="moreTextLink" href="<?php echo $image_url[$cur_img]; ?>" target="<?php echo $target_url[$cur_img]; ?>"><?php echo $readmore_text; ?></a>						
				</div>
			<?php } ?>
		<?php } else { ?>
			<img src="<?php echo $image_img[$cur_img]; ?>" alt="<?php echo $image_alt[$cur_img]; ?>" />
			<div class="cover boxcaption" style="background:<?php echo $image_caption_color[$cur_img]; ?> !important;">
				<div class="teaser-title" style="color:<?php echo $title_color; ?>; <?php echo $title_css; ?>"><?php echo $image_title[$cur_img]; ?></div>
				<div class="teaser-text" style="color:<?php echo $teaser_color; ?>; "><?php echo $image_teaser[$cur_img]; ?></div>
			</div>
		<?php } ?>			
	</div>
	<?php if ( $image_url[$cur_img] && $url_link_type == 3 && ($imagenr < $image_cnt) )  { ?>
	</div>
	<?php }
	}	
	$imagenr++;
	}	// end row
}; // end gallery ?>
</div> 

<div style="clear:both;"></div>

